
  MAKROTList = class(TObject)
  private
    FList: TFPMList;
  protected
    function Get(Index: Integer): MAKROPointerType;
    procedure Grow; virtual;
    procedure Put(Index: Integer; Item: MAKROPointerType);
    procedure Notify(Ptr: MAKROPointerType; Action: TListNotification); virtual;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCapacity: integer;
    procedure SetCount(NewCount: Integer);
    function GetCount: integer;
    function GetList: PPointerList;
  public
    constructor Create;
    destructor Destroy; override;
    function Add(Item: MAKROPointerType): Integer;
    procedure Clear; virtual;
    procedure Delete(Index: Integer);
    class procedure Error(const Msg: string; Data: PtrInt); virtual;
    procedure Exchange(Index1, Index2: Integer);
    function Expand: MAKROTList;
    function Extract(item: MAKROPointerType): MAKROPointerType;
    function First: MAKROPointerType;
    function IndexOf(Item: MAKROPointerType): Integer;
    procedure Insert(Index: Integer; Item: MAKROPointerType);
    function Last: MAKROPointerType;
    procedure Move(CurIndex, NewIndex: Integer);
    procedure Assign(Obj:MAKROTList);
    function Remove(Item: MAKROPointerType): Integer;
    procedure Pack;
    procedure Sort(Compare: TListSortCompare);
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: MAKROPointerType read Get write Put; default;
    property List: PPointerList read GetList;
  end;

